CREATE TEMPORARY TABLE tmp_r_ids (
  grouped_ids TEXT NOT NULL,
  min_id INT NOT NULL,
) TRANSACTIONAL AS
SELECT '|' || GROUP_CONCAT(id SEPARATOR '|') || '|' as ids, MIN(id)
 FROM role
 GROUP BY lower(name)
 HAVING count(*) > 1;

-- update user role
CALL ls_run_until('
MERGE INTO license_server_user (id, role_id) KEY (id)
  SELECT u.id, ids.min_id
  FROM license_server_user u
  JOIN tmp_r_ids ids ON LOCATE(`|` || u.role_id || `|`, ids.grouped_ids) > 0 AND u.role_id <> ids.min_id
LIMIT 1000');

CALL ls_run_until('
DELETE FROM role WHERE
  EXISTS (SELECT 1 FROM tmp_r_ids WHERE LOCATE(`|` || id || `|`, grouped_ids) > 0)
  AND id NOT IN (SELECT min_id FROM tmp_r_ids)
LIMIT 1000');

DROP TABLE tmp_r_ids;
