$(function () {
  var sendClosed = function (id) {
    $.post(LS.routes.notificationClosedUrl + '?' + $.param({
      id: id
    }));
  };
  var sendShow = function (id) {
    $.post(LS.routes.notificationOpenedUrl + '?' + $.param({
      id: id
    }));
  };

  var showWithDelay = function (notification) {
    setTimeout(function () {
      $.notify({
        title: notification.title,
        message: notification.message
      }, {
        onClose: function () {
          sendClosed(notification.id);
        },
        onShow: function () {
          sendShow(notification.id);
        }
      });
    }, 3000);
  };

  var showImmediately = function (notification) {
    $.notify({
      title: notification.title,
      message: notification.message
    }, {
      onClose: function () {
        sendClosed(notification.id);
      },
      onShow: function () {
        sendShow(notification.id);
      },
      animate: {
        enter: ''
      }
    });
  };

  $.notifyDefaults({
    delay: 0,
    animate: {
      enter: 'animated fadeInRight',
      exit: 'animated fadeOutRight'
    },
    offset: {
      x: 30,
      y: 120
    },
    template: '' +
    '<div data-notify="container" class="zt-notification">' +
    '   <div class="header">' +
    '     <i class="fa fa-info-circle" aria-hidden="true"></i>' +
    '     <button type="button" class="close" aria-hidden="true" data-notify="dismiss">×</button>' +
    '     <span>{1}</span>' +
    '   </div>' +
    '   <div class="body">' +
    '     <p>{2}</p>' +
    '   </div>' +
    '   <div class="buttons-wrapper">' +
    '     <button class="btn btn-primary" data-notify="dismiss" aria-hidden="true">Got it!</button>' +
    '   </div>' +
    '</div>'
  });

  $.getJSON(LS.routes.getNotifications)
  .success(function(data) {
    $.each(data, function (idx, notification) {
      if (notification.state === "NEW") {
        showWithDelay(notification);
      }
      else if (notification.state === "OPEN") {
        showImmediately(notification);
      }
    });
  });

});